#
# shinGETsu - P2P anonymous BBS
#
# (c) FukTommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: Extern.pm,v 1.14 2004/02/01 06:09:31 fuktommy Exp $
#

package Shingetsu::Extern;
use SelfLoader;
use Shingetsu::Config;

1;
__DATA__;

#
# mime base-64 encode
#
sub base64encode {
	use MIME::Base64;
	return encode_base64($_[0], "");
}

#
# mime base-64 decode
#
sub base64decode {
	use MIME::Base64;
	return decode_base64($_[0]);
}

#
# md5 message-digest
#
sub md5digest {
	use Digest::MD5 qw(md5_hex);
	return md5_hex($_[0]);
}

#
# gzip
#
sub xgzip {
	use Compress::Zlib;
	return Compress::Zlib::memGzip($_[0]);
}

#
# gunzip
#
sub xgunzip {
	use Compress::Zlib;
	my $buf = Compress::Zlib::memGunzip(join "", @_);
	my @buf = split /\n/, $buf;
	local $_;
	$_ .= "\n" foreach (@buf);
	chop $buf[-1] if ($buf !~ /\n$/);
	return @buf;
}

#
# wget
#
sub wget {
	use LWP::UserAgent;
	use HTTP::Response;
	local $_;
	my $ua = new LWP::UserAgent(
			agent		=> "shinGETsu/$Shingetsu::Config::version",
			env_proxy	=> 0,
			keep_alive	=> 0,
			timeout		=> $Shingetsu::Config::timeout,
		);
	my $res = $ua->get($_[0], "Accept-Encoding" =>"gzip");
	my $buf = $res->as_string;
	chop $buf;
	my @buf = split /\n/, $buf;
	$_ .= "\n" foreach (@buf);
	chop $buf[-1] if ($buf !~ /\n$/);
	return @buf;
}

1;
