#
# shinGETsu - P2P anonymous BBS
#
# (c) FukTommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: Signature.pm,v 1.1 2004/02/11 14:36:02 fuktommy Exp $
#

package Shingetsu::Signature;
use Shingetsu::Config;
use Shingetsu::Extern;

$trustlist = $Shingetsu::Config::trust;

#
# make sigunature
#
sub generate($$) {
	my($prikey, $str) = @_;
	return ("PUBKEY", "SIGN");
}

#
# check sigunature
#
sub check(%) {
	my(%rec) = @_;
	my($str, $t) = ("", "");
	foreach $t (split /,/, $rec{target}) {
		$str .= "<>$t:$rec{$t}";
	}
	$str =~ s/^<>//;
	$value = $str;
	return (($rec{pubkey} eq "PUBKEY") && ($rec{sign} eq "SIGN"));
}

#
# make public key readable string
#
sub pubkey2trip($) {
	my($pubkey) = @_;
	return lc($pubkey);
}

#
# add trip to trust list
#
sub addlist($) {
	my($trip) = @_;
	local $_;
	unless (include($trip)) {
		Shingetsu::Util::lock();
		open OUT, ">> $trustlist" or die "$trustlist: open failed. $!";
		print OUT "$trip\n";
		close OUT;
		Shingetsu::Util::unlock();
	}
}

#
# remove trip from list
#
sub dellist($) {
	my($trip) = @_;
	$trip .= "\n";
	local $_;
	my @trip;
	if (-e $trustlist) {
		open IN, $trustlist or exit;
		@trip = <IN>;
		close IN;
	} else {
		return;
	}
	if (grep $_ eq $trip, @trip) {
		Shingetsu::Util::lock();
		open OUT, "> $trustlist" or die "$trustlist: open failed. $!";
		foreach (@trip) {
			print OUT if ($_ ne $trip);
		}
		close OUT;
		Shingetsu::Util::unlock();
	}
}

#
# include trip
#
sub include($) {
	my($trip) = @_;
	my @trip = list();
	if (grep $_ eq $trip, @trip) {
		return 1;
	} else {
		return undef;
	}
}

#
# show all trip
#
sub list() {
	local $_;
	open IN, $trustlist or return ();
	my @trip = <IN>;
	chomp @trip;
	return @trip;
}

1;
